# autogenerated by genmsg_py from PR2ArmIKGoal.msg. Do not edit.
import roslib.message
import struct

import roslib.rostime
import geometry_msgs.msg
import roslib.msg
import sensor_msgs.msg

class PR2ArmIKGoal(roslib.message.Message):
  _md5sum = "8b22d3ec2fe1ddbbe17f34799f68533c"
  _type = "pr2_common_action_msgs/PR2ArmIKGoal"
  _has_header = False #flag to mark the presence of a Header object
  _full_text = """# ====== DO NOT MODIFY! AUTOGENERATED FROM AN ACTION DEFINITION ======
#goal definition
geometry_msgs/PoseStamped pose
sensor_msgs/JointState ik_seed
duration ik_timeout
duration move_duration

================================================================================
MSG: geometry_msgs/PoseStamped
# A Pose with reference coordinate frame and timestamp
Header header
Pose pose

================================================================================
MSG: roslib/Header
# Standard metadata for higher-level stamped data types.
# This is generally used to communicate timestamped data 
# in a particular coordinate frame.
# 
# sequence ID: consecutively increasing ID 
uint32 seq
#Two-integer timestamp that is expressed as:
# * stamp.secs: seconds (stamp_secs) since epoch
# * stamp.nsecs: nanoseconds since stamp_secs
# time-handling sugar is provided by the client library
time stamp
#Frame this data is associated with
# 0: no frame
# 1: global frame
string frame_id

================================================================================
MSG: geometry_msgs/Pose
# A representation of pose in free space, composed of postion and orientation. 
Point position
Quaternion orientation

================================================================================
MSG: geometry_msgs/Point
# This contains the position of a point in free space
float64 x
float64 y
float64 z

================================================================================
MSG: geometry_msgs/Quaternion
# This represents an orientation in free space in quaternion form.

float64 x
float64 y
float64 z
float64 w

================================================================================
MSG: sensor_msgs/JointState
# This is a message that holds data to describe the state of a set of torque controlled joints. 
#
# The state of each joint is defined by:
#  * the position of the joint, 
#  * the velocity of the joint and 
#  * the effort that is applied in the joint.
#
# Each joint is uniquely identified by its name
# The header specifies the time at which the joint states were recorded. All the joint states
# in one message have to be recorded at the same time.
#
# This message consists of a multiple arrays, one for each part of the joint state. 
# The goal is to make each of the fields optional. When e.g. your joints have no
# effort associated with them, you can leave the effort array empty. 
#
# All arrays in this message should have the same size, or be empty.
# This is the only way to uniquely associate the joint name with the correct
# states.


Header header

string[] name
float64[] position
float64[] velocity
float64[] effort

"""
  __slots__ = ['pose','ik_seed','ik_timeout','move_duration']
  _slot_types = ['geometry_msgs/PoseStamped','sensor_msgs/JointState','duration','duration']

  ## Constructor. Any message fields that are implicitly/explicitly
  ## set to None will be assigned a default value. The recommend
  ## use is keyword arguments as this is more robust to future message
  ## changes.  You cannot mix in-order arguments and keyword arguments.
  ##
  ## The available fields are:
  ##   pose,ik_seed,ik_timeout,move_duration
  ##
  ## @param self: self
  ## @param args: complete set of field values, in .msg order
  ## @param kwds: use keyword arguments corresponding to message field names
  ## to set specific fields. 
  def __init__(self, *args, **kwds):
    if args or kwds:
      super(PR2ArmIKGoal, self).__init__(*args, **kwds)
      #message fields cannot be None, assign default values for those that are
      if self.pose is None:
        self.pose = geometry_msgs.msg.PoseStamped()
      if self.ik_seed is None:
        self.ik_seed = sensor_msgs.msg.JointState()
      if self.ik_timeout is None:
        self.ik_timeout = roslib.rostime.Duration()
      if self.move_duration is None:
        self.move_duration = roslib.rostime.Duration()
    else:
      self.pose = geometry_msgs.msg.PoseStamped()
      self.ik_seed = sensor_msgs.msg.JointState()
      self.ik_timeout = roslib.rostime.Duration()
      self.move_duration = roslib.rostime.Duration()

  ## internal API method
  def _get_types(self): return self._slot_types

  ## serialize message into buffer
  ## @param buff StringIO: buffer
  def serialize(self, buff):
    try:
      buff.write(struct.pack('<3I', self.pose.header.seq, self.pose.header.stamp.secs, self.pose.header.stamp.nsecs))
      length = len(self.pose.header.frame_id)
      #serialize self.pose.header.frame_id
      buff.write(struct.pack('<I%ss'%length, length, self.pose.header.frame_id))
      buff.write(struct.pack('<7d3I', self.pose.pose.position.x, self.pose.pose.position.y, self.pose.pose.position.z, self.pose.pose.orientation.x, self.pose.pose.orientation.y, self.pose.pose.orientation.z, self.pose.pose.orientation.w, self.ik_seed.header.seq, self.ik_seed.header.stamp.secs, self.ik_seed.header.stamp.nsecs))
      length = len(self.ik_seed.header.frame_id)
      #serialize self.ik_seed.header.frame_id
      buff.write(struct.pack('<I%ss'%length, length, self.ik_seed.header.frame_id))
      #serialize self.ik_seed.name
      length = len(self.ik_seed.name)
      buff.write(struct.pack('<I', length))
      for val1 in self.ik_seed.name:
        length = len(val1)
        #serialize val1
        buff.write(struct.pack('<I%ss'%length, length, val1))
      #serialize self.ik_seed.position
      length = len(self.ik_seed.position)
      buff.write(struct.pack('<I', length))
      pattern = '<%sd'%length
      buff.write(struct.pack(pattern, *self.ik_seed.position))
      #serialize self.ik_seed.velocity
      length = len(self.ik_seed.velocity)
      buff.write(struct.pack('<I', length))
      pattern = '<%sd'%length
      buff.write(struct.pack(pattern, *self.ik_seed.velocity))
      #serialize self.ik_seed.effort
      length = len(self.ik_seed.effort)
      buff.write(struct.pack('<I', length))
      pattern = '<%sd'%length
      buff.write(struct.pack(pattern, *self.ik_seed.effort))
      buff.write(struct.pack('<4i', self.ik_timeout.secs, self.ik_timeout.nsecs, self.move_duration.secs, self.move_duration.nsecs))
    except struct.error, se: self._check_types(se)
    except TypeError, te: self._check_types(te)

  ## unpack serialized message in str into this message instance
  ## @param self: self
  ## @param str str: byte array of serialized message
  def deserialize(self, str):
    try:
      if self.pose is None:
        self.pose = geometry_msgs.msg.PoseStamped()
      if self.ik_seed is None:
        self.ik_seed = sensor_msgs.msg.JointState()
      if self.ik_timeout is None:
        self.ik_timeout = roslib.rostime.Duration()
      if self.move_duration is None:
        self.move_duration = roslib.rostime.Duration()
      end = 0
      start = end
      end += 12
      (self.pose.header.seq, self.pose.header.stamp.secs, self.pose.header.stamp.nsecs,) = struct.unpack('<3I',str[start:end])
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      #deserialize self.pose.header.frame_id
      pattern = '<%ss'%length
      start = end
      end += struct.calcsize(pattern)
      (self.pose.header.frame_id,) = struct.unpack(pattern, str[start:end])
      start = end
      end += 68
      (self.pose.pose.position.x, self.pose.pose.position.y, self.pose.pose.position.z, self.pose.pose.orientation.x, self.pose.pose.orientation.y, self.pose.pose.orientation.z, self.pose.pose.orientation.w, self.ik_seed.header.seq, self.ik_seed.header.stamp.secs, self.ik_seed.header.stamp.nsecs,) = struct.unpack('<7d3I',str[start:end])
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      #deserialize self.ik_seed.header.frame_id
      pattern = '<%ss'%length
      start = end
      end += struct.calcsize(pattern)
      (self.ik_seed.header.frame_id,) = struct.unpack(pattern, str[start:end])
      #deserialize self.ik_seed.name
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      self.ik_seed.name = []
      for i in xrange(0, length):
        start = end
        end += 4
        (length,) = struct.unpack('<I',str[start:end])
        #deserialize val1
        pattern = '<%ss'%length
        start = end
        end += struct.calcsize(pattern)
        (val1,) = struct.unpack(pattern, str[start:end])
        self.ik_seed.name.append(val1)
      #deserialize self.ik_seed.position
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      pattern = '<%sd'%length
      start = end
      end += struct.calcsize(pattern)
      self.ik_seed.position = struct.unpack(pattern, str[start:end])
      #deserialize self.ik_seed.velocity
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      pattern = '<%sd'%length
      start = end
      end += struct.calcsize(pattern)
      self.ik_seed.velocity = struct.unpack(pattern, str[start:end])
      #deserialize self.ik_seed.effort
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      pattern = '<%sd'%length
      start = end
      end += struct.calcsize(pattern)
      self.ik_seed.effort = struct.unpack(pattern, str[start:end])
      start = end
      end += 16
      (self.ik_timeout.secs, self.ik_timeout.nsecs, self.move_duration.secs, self.move_duration.nsecs,) = struct.unpack('<4i',str[start:end])
      self.ik_timeout.canon()
      self.move_duration.canon()
      return self
    except struct.error, e:
      raise roslib.message.DeserializationError(e) #most likely buffer underfill


  ## serialize message with numpy array types into buffer
  ## @param self: self
  ## @param buff StringIO: buffer
  ## @param numpy module: numpy python module
  def serialize_numpy(self, buff, numpy):
    try:
      buff.write(struct.pack('<3I', self.pose.header.seq, self.pose.header.stamp.secs, self.pose.header.stamp.nsecs))
      length = len(self.pose.header.frame_id)
      #serialize self.pose.header.frame_id
      buff.write(struct.pack('<I%ss'%length, length, self.pose.header.frame_id))
      buff.write(struct.pack('<7d3I', self.pose.pose.position.x, self.pose.pose.position.y, self.pose.pose.position.z, self.pose.pose.orientation.x, self.pose.pose.orientation.y, self.pose.pose.orientation.z, self.pose.pose.orientation.w, self.ik_seed.header.seq, self.ik_seed.header.stamp.secs, self.ik_seed.header.stamp.nsecs))
      length = len(self.ik_seed.header.frame_id)
      #serialize self.ik_seed.header.frame_id
      buff.write(struct.pack('<I%ss'%length, length, self.ik_seed.header.frame_id))
      #serialize self.ik_seed.name
      length = len(self.ik_seed.name)
      buff.write(struct.pack('<I', length))
      for val1 in self.ik_seed.name:
        length = len(val1)
        #serialize val1
        buff.write(struct.pack('<I%ss'%length, length, val1))
      #serialize self.ik_seed.position
      length = len(self.ik_seed.position)
      buff.write(struct.pack('<I', length))
      pattern = '<%sd'%length
      buff.write(self.ik_seed.position.tostring())
      #serialize self.ik_seed.velocity
      length = len(self.ik_seed.velocity)
      buff.write(struct.pack('<I', length))
      pattern = '<%sd'%length
      buff.write(self.ik_seed.velocity.tostring())
      #serialize self.ik_seed.effort
      length = len(self.ik_seed.effort)
      buff.write(struct.pack('<I', length))
      pattern = '<%sd'%length
      buff.write(self.ik_seed.effort.tostring())
      buff.write(struct.pack('<4i', self.ik_timeout.secs, self.ik_timeout.nsecs, self.move_duration.secs, self.move_duration.nsecs))
    except struct.error, se: self._check_types(se)
    except TypeError, te: self._check_types(te)

  ## unpack serialized message in str into this message instance using numpy for array types
  ## @param self: self
  ## @param str str: byte array of serialized message
  ## @param numpy module: numpy python module
  def deserialize_numpy(self, str, numpy):
    try:
      if self.pose is None:
        self.pose = geometry_msgs.msg.PoseStamped()
      if self.ik_seed is None:
        self.ik_seed = sensor_msgs.msg.JointState()
      if self.ik_timeout is None:
        self.ik_timeout = roslib.rostime.Duration()
      if self.move_duration is None:
        self.move_duration = roslib.rostime.Duration()
      end = 0
      start = end
      end += 12
      (self.pose.header.seq, self.pose.header.stamp.secs, self.pose.header.stamp.nsecs,) = struct.unpack('<3I',str[start:end])
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      #deserialize self.pose.header.frame_id
      pattern = '<%ss'%length
      start = end
      end += struct.calcsize(pattern)
      (self.pose.header.frame_id,) = struct.unpack(pattern, str[start:end])
      start = end
      end += 68
      (self.pose.pose.position.x, self.pose.pose.position.y, self.pose.pose.position.z, self.pose.pose.orientation.x, self.pose.pose.orientation.y, self.pose.pose.orientation.z, self.pose.pose.orientation.w, self.ik_seed.header.seq, self.ik_seed.header.stamp.secs, self.ik_seed.header.stamp.nsecs,) = struct.unpack('<7d3I',str[start:end])
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      #deserialize self.ik_seed.header.frame_id
      pattern = '<%ss'%length
      start = end
      end += struct.calcsize(pattern)
      (self.ik_seed.header.frame_id,) = struct.unpack(pattern, str[start:end])
      #deserialize self.ik_seed.name
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      self.ik_seed.name = []
      for i in xrange(0, length):
        start = end
        end += 4
        (length,) = struct.unpack('<I',str[start:end])
        #deserialize val1
        pattern = '<%ss'%length
        start = end
        end += struct.calcsize(pattern)
        (val1,) = struct.unpack(pattern, str[start:end])
        self.ik_seed.name.append(val1)
      #deserialize self.ik_seed.position
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      pattern = '<%sd'%length
      start = end
      end += struct.calcsize(pattern)
      self.ik_seed.position = numpy.frombuffer(str[start:end], dtype=numpy.float64, count=length)
      #deserialize self.ik_seed.velocity
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      pattern = '<%sd'%length
      start = end
      end += struct.calcsize(pattern)
      self.ik_seed.velocity = numpy.frombuffer(str[start:end], dtype=numpy.float64, count=length)
      #deserialize self.ik_seed.effort
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      pattern = '<%sd'%length
      start = end
      end += struct.calcsize(pattern)
      self.ik_seed.effort = numpy.frombuffer(str[start:end], dtype=numpy.float64, count=length)
      start = end
      end += 16
      (self.ik_timeout.secs, self.ik_timeout.nsecs, self.move_duration.secs, self.move_duration.nsecs,) = struct.unpack('<4i',str[start:end])
      self.ik_timeout.canon()
      self.move_duration.canon()
      return self
    except struct.error, e:
      raise roslib.message.DeserializationError(e) #most likely buffer underfill

